package com.gmh.controller;

import cn.hutool.core.util.StrUtil;
import com.gmh.entity.GmhUser;
import com.gmh.entity.R;
import com.gmh.utils.POIExcelUtil;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.*;

@RestController
@RequestMapping("/excel")
public class ExcelController {

    @RequestMapping("/t01")
    public R test01() {
        return R.ok("ok");
    }

    @RequestMapping("/readData")
    public R readSourceData(MultipartFile file) throws IOException {
        Workbook workbook = POIExcelUtil.readExcelFromInputStream(file.getInputStream(), file.getOriginalFilename());
        Integer nameCellIndex = null;
        Map<String, List<GmhUser>> sheetNameList = new LinkedHashMap<>();
        for (int i = 0; i < workbook.getNumberOfSheets(); i++) {
            List<GmhUser> nameList = new ArrayList<>();
            Sheet sheet = workbook.getSheetAt(i);
            for (int r = 0; r <= sheet.getLastRowNum(); r++) {
                Row row = sheet.getRow(r);
                if (row == null) {
                    continue;
                }
                int lastCellNum = row.getLastCellNum();
                for (int c = 0; c < lastCellNum; c++) {
                    Cell cell = row.getCell(c);
                    String stringCellValue = POIExcelUtil.getStringCellValExcludeBlank(cell);
                    if (r == 0) {
                        // 第一行有姓名列
                        if ("姓名".equals(stringCellValue)) {
                            nameCellIndex = c;
                            break;
                        } else {
                            // 第一列没有姓名的情况
                        }
                    }
                }
                if (nameCellIndex != null) {
                    Cell cell = row.getCell(nameCellIndex);
                    String stringCellValue = POIExcelUtil.getStringCellValExcludeBlank(cell);
                    if (!"姓名".equals(stringCellValue) && StrUtil.isNotBlank(stringCellValue)) {
                        GmhUser user = new GmhUser();
                        user.setName(stringCellValue);
                        nameList.add(user);
                    }
                } else {
                    System.out.println("未找到姓名列");
                }
            }
            if (!nameList.isEmpty()) {
                sheetNameList.put(sheet.getSheetName(), nameList);
            }
        }
        return R.ok().setData(sheetNameList);
    }

    @RequestMapping("/template")
    public R templateUpload(MultipartFile file) throws IOException {
        Workbook workbook = POIExcelUtil.readExcelFromInputStream(file.getInputStream(), file.getOriginalFilename());

        return R.ok();
    }


}
